package model

import "shylinux.com/x/mysql-story/src/db"

const (
	UID              = "uid"
	NAME             = "name"
	TYPE             = "type"
	ROLE             = "role"
	LINK             = "link"
	TITLE            = "title"
	CONTENT          = "content"
	USER_UID         = "user_uid"
	USER_ISSUER_ROLE = "user_issuer_role"
	ISSUER_UID       = "issuer_uid"
	ISSUER_NAME      = "issuer_name"
	ISSUER_TYPE      = "issuer_type"
	DOCUMENT_UID     = "document_uid"
	DOCUMENT_TYPE    = "document_type"
	COMPANY_UID      = "company_uid"
	CITY_UID         = "city_uid"
	INDEX            = "index"
	INIT             = "init"
)

type UserIssuer struct {
	db.ModelWithUID
	UserUID   string `gorm:"type:char(32);index"`
	IssuerUID string `gorm:"type:char(32);index"`
	Role      uint8  `gorm:"default:0"`
}
type Issuer struct {
	db.ModelWithUID
	CompanyUID string `gorm:"type:char(32);index"`
	Name       string `gorm:"type:varchar(64)"`
	Type       uint8  `gorm:"default:0"`
	Link       string `gorm:"type:varchar(255)"`
	Init       uint8
}
type Document struct {
	db.ModelWithUID
	IssuerUID string `gorm:"type:char(32);index"`
	UserUID   string `gorm:"type:char(32);index"`
	School    string `gorm:"type:varchar(32)"`
	Subject   string `gorm:"type:varchar(32)"`
	Grade     string `gorm:"type:varchar(32)"`
	Type      uint8  `gorm:"default:0"`
	Icon      string `gorm:"type:varchar(64)"`
	Link      string `gorm:"type:varchar(255)"`
	Title     string `gorm:"type:varchar(64)"`
	Content   string
}

func init() { db.CmdModels("", &UserIssuer{}, &Issuer{}, &Document{}) }
