package jiaocaiziliao

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/education/src/jiaocaiziliao/model"
)

type userIssuer struct {
	Table
	issuer issuer
}

func (s userIssuer) User(m *ice.Message, arg ...string) {
	s.FieldsWithCreatedAT(m, s, model.USER_UID, model.ROLE)
	if len(arg) == 1 {
		s.Select(m, model.ISSUER_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.ISSUER_UID, arg[0], model.UID, arg[1])
	} else {
		return
	}
	m.RenameAppend(model.ROLE, model.USER_ISSUER_ROLE)
	s.SelectJoinUser(m)
}
func (s userIssuer) List(m *ice.Message, arg ...string) {
	s.Tables(m, s.issuer).FieldsWithCreatedAT(m, s,
		model.ISSUER_NAME, model.ISSUER_TYPE, model.USER_ISSUER_ROLE,
		model.COMPANY_UID, model.ISSUER_UID,
		model.INIT, model.LINK,
	)
	if len(arg) == 1 {
		s.Select(m, model.USER_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.USER_UID, arg[0], s.Key(s, model.ISSUER_UID), arg[1])
	} else {
		return
	}
	s.SelectJoinCompany(m)
	s.SelectJoinCity(m)
}

func init() { ice.TeamCtxCmd(userIssuer{}) }

type UserIssuerRole int

const (
	UserIssuerVisitor UserIssuerRole = iota
	UserIssuerCreator
	UserIssuerLeader
	UserIssuerWorker
	UserIssuerServer
)

var UserIssuerRoleList = map[UserIssuerRole]string{
	UserIssuerVisitor: "visitor",
	UserIssuerCreator: "creator",
	UserIssuerLeader:  "leader",
	UserIssuerWorker:  "worker",
	UserIssuerServer:  "server",
}

func (s UserIssuerRole) String() string { return UserIssuerRoleList[s] }
