package zaixianketang

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/education/src/zaixianketang/model"
)

type userCourse struct {
	Table
	course  course
}

func (s userCourse) User(m *ice.Message, arg ...string) {
	s.FieldsWithCreatedAT(m, s, model.USER_UID, model.ROLE)
	if len(arg) == 1 {
		s.Select(m, model.COURSE_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.COURSE_UID, arg[0], model.UID, arg[1])
	} else {
		return
	}
	m.RenameAppend(model.ROLE, model.USER_COURSE_ROLE)
	s.SelectJoinUser(m)
}
func (s userCourse) List(m *ice.Message, arg ...string) {
	s.Tables(m, s.course).FieldsWithCreatedAT(m, s,
		model.COURSE_NAME, model.COURSE_TYPE, model.USER_COURSE_ROLE,
		model.COMPANY_UID, model.COURSE_UID,
	)
	if len(arg) == 1 {
		s.Select(m, model.USER_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.USER_UID, arg[0], s.Key(s, model.COURSE_UID), arg[1])
	} else {
		return
	}
	s.SelectJoinCompany(m)
	s.SelectJoinCity(m)
}

func init() { ice.TeamCtxCmd(userCourse{}) }

type UserCourseRole int

const (
	UserCourseVisitor UserCourseRole = iota
	UserCourseCreator
	UserCourseLeader
	UserCourseWorker
	UserCourseServer
)

var UserCourseRoleList = map[UserCourseRole]string{
	UserCourseVisitor: "visitor",
	UserCourseCreator: "creator",
	UserCourseLeader: "leader",
	UserCourseWorker: "worker",
	UserCourseServer: "server",
}

func (s UserCourseRole) String() string { return UserCourseRoleList[s] }