package zhengshuxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/enterprise/src/guanlixitong"
	"shylinux.com/x/education/src/zhengshuxitong/model"
)

type Table struct {
	guanlixitong.Table
	list string `name:"list auth_uid uid auto" role:"void"`
}

func (s Table) Inputs(m *ice.Message, arg ...string) {
	switch arg[0] {
	case model.USER_AUTH_ROLE:
		s.InputsListRole(m, UserAuthRoleList, arg...)
	case model.AUTH_TYPE:
		s.InputsList(m, AuthTypeList, arg...)
	default:
		s.Table.Inputs(m, arg...)
	}
}
func (s Table) RewriteAppend(m *ice.Message, arg ...string) *ice.Message {
	m.RewriteAppend(func(value, key string, index int) string {
		switch key {
		case model.USER_AUTH_ROLE:
			value = UserAuthRole(kit.Int(value)).String()
		case model.AUTH_TYPE:
			value = AuthType(kit.Int(value)).String()
		}
		return value
	})
	return s.Table.RewriteAppend(m)
}
func (s Table) CheckRole(m *ice.Message, arg ...string) *ice.Message {
	role := UserAuthRole(kit.Int(m.Cmd(userAuth{}, s.Select, m.OptionSimple(model.AUTH_UID, model.USER_UID)).Append(model.ROLE)))
	m.WarnNotRight(!kit.IsIn(role.String(), append(arg, UserAuthCreator.String())...), role.String())
	return m
}
func (s Table) recordEvent(m *ice.Message, info string, arg ...string) {
	s.Table.RecordEvent(m, m.Option(model.AUTH_UID), info, kit.Select(m.Option(model.UID), arg, 0))
}
func (s Table) recordEventWithName(m *ice.Message, info string, arg ...string) {
	s.Table.RecordEventWithName(m, m.Option(model.AUTH_UID), info)
}

type Tables struct { Table }

func (s Tables) BeforeMigrate(m *ice.Message, arg ...string) {}