package zhengshuxitong

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/education/src/zhengshuxitong/model"
)

type userAuth struct {
	Table
	auth  auth
}

func (s userAuth) User(m *ice.Message, arg ...string) {
	s.FieldsWithCreatedAT(m, s, model.USER_UID, model.ROLE)
	if len(arg) == 1 {
		s.Select(m, model.AUTH_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.AUTH_UID, arg[0], model.UID, arg[1])
	} else {
		return
	}
	m.RenameAppend(model.ROLE, model.USER_AUTH_ROLE)
	s.SelectJoinUser(m)
}
func (s userAuth) List(m *ice.Message, arg ...string) {
	s.Tables(m, s.auth).FieldsWithCreatedAT(m, s,
		model.AUTH_NAME, model.AUTH_TYPE, model.USER_AUTH_ROLE,
		model.COMPANY_UID, model.AUTH_UID,
	)
	if len(arg) == 1 {
		s.Select(m, model.USER_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.USER_UID, arg[0], s.Key(s, model.AUTH_UID), arg[1])
	} else {
		return
	}
	s.SelectJoinCompany(m)
	s.SelectJoinCity(m)
}

func init() { ice.TeamCtxCmd(userAuth{}) }

type UserAuthRole int

const (
	UserAuthVisitor UserAuthRole = iota
	UserAuthCreator
	UserAuthLeader
	UserAuthWorker
	UserAuthServer
)

var UserAuthRoleList = map[UserAuthRole]string{
	UserAuthVisitor: "visitor",
	UserAuthCreator: "creator",
	UserAuthLeader: "leader",
	UserAuthWorker: "worker",
	UserAuthServer: "server",
}

func (s UserAuthRole) String() string { return UserAuthRoleList[s] }